import fire
import os
from guang.Utils.toolsFunc import path, replace_files_content
from guang.cv.video import resample, embedFrameInfo
from guang.media.ffmpeg import *


def replace(old, new, pathname='./**/*'):
    """ Replace files content from the given path.
    :param pathname: `glob` style path
    :param count: replace count. if count=0, relplace all
    """
    replace_files_content(old, new, pathname=pathname, count=0)


def ppath(string, file=__file__) -> str:
    """Path in package"""
    return path(os.path.join(os.path.dirname(file), string))


def fy(words):
    from guang.translate.run import tencent
    tencent(words)


def mie():
    origin_wd = os.getcwd()
    os.chdir(path(r"C:\BaiduNetdiskDownload\CODE\a_github\ScatteringLight"))
    os.system("streamlit run app.py")
    os.chdir(origin_wd)


def lorenz():
    app_path = ppath("app/compose/anim_demo.py")
    os.system(f"streamlit run {app_path}")


def sawtooth():
    file_path = ppath("app/compose/slider.py")
    os.system(f"python {file_path}")


def geo():
    file_path = ppath("geo/compose.py")
    os.system(f"python {file_path}")


def fourier():
    print()
    app_path = ppath("sci/fourier_app.py")
    print(app_path)
    os.system(f"streamlit run {app_path}")


def multi_cvt2wav(PATH1, PATH2, FORMAT='*', sr=16000, n_cpu=None):
    """
    :arg PATH1: Input folder path
    :arg PATH2: Output folder path
    :arg FORMAT: Input voice format,  default all files
    :arg sr: Sample rate, default:16000
    :arg n_cpu: Number of multiple processes
    """
    from guang.Voice.convert import multi_cvt2wav as cvt
    cvt(PATH1, PATH2, FORMAT, sr, n_cpu)


def upload(PAHT1="upload/", PATH2="/var/www/html/"):
    from syncnote import Cloud

    def download(
        remote_path: str,
        local_path: str,
        config_path=r"C:\BaiduNetdiskDownload\CODE\a_github\myWebsite\config.yaml"
    ):
        cloud = Cloud(config_path)
        cloud.remote_walk(remote_path)
        cloud.local_walk(local_path)
        cloud.download()

    def upload(
        local_path: str,
        remote_path: str,
        config_path=r"C:\BaiduNetdiskDownload\CODE\a_github\myWebsite\config.yaml"
    ):
        cloud = Cloud(config_path)
        cloud.remote_walk(remote_path)
        cloud.local_walk(local_path)
        cloud.upload()

    upload(PAHT1, PATH2)


func_list = [
    replace,
    mie,
    lorenz,
    geo,
    sawtooth,
    multi_cvt2wav,
    fourier,
    embedFrameInfo,
    resample,
    resample_fps,
    av_speed,
    video_speed,
    audio_speed,
]

func_dict = {}
for func in func_list:
    func_dict[func.__name__] = func


def main():
    fire.Fire(func_dict)


if __name__ == "__main__":
    main()
